#include <bits/stdc++.h>
using namespace std;
int main()
{
	int n,m;
	scanf("%i %i",&n,&m);
	vector<vector<int>> mat;
	mat.assign(n,vector<int>(m));
	for(int i=0;i<n;i++) for(int j=0;j<m;j++) scanf("%i",&mat[i][j]);
	vector<int> ans(m,1);
	for(int i=0;i<n;i++)
	{
		int l=-1,sum=0;
        for(int j=0;j<m;j++)
		{
			if(mat[i][j]==1)
			{
				if(l==-1) ans[j]+=sum;
				else
				{
					ans[j]+=sum/2,ans[l]+=sum/2;
					if(sum&1)
					{
						if(i&1) ans[j]++;
						else ans[l]++;
					}
				}
				sum=0;
				l=j;
			}
			else sum+=ans[j],ans[j]=0;
		}
		if(l!=-1) ans[l]+=sum;
	}
	for(int j=0;j<m;j++) printf("%i ",ans[j]);
	printf("\n");
	return 0;
}